LOCAL_PATH := $(call my-dir)
include $(CLEAR_VARS)

# List obtained using
# adb shell busybox --list |sed 's/.$/ \\/' |sed 's/^/\t/'
BUSYBOX_TOOLS := \
	[ \
	[[ \
	acpid \
	add-shell \
	addgroup \
	adduser \
	adjtimex \
	ar \
	arp \
	arping \
	ash \
	awk \
	base64 \
	basename \
	bash \
	beep \
	blkid \
	blockdev \
	bootchartd \
	brctl \
	bunzip2 \
	bzcat \
	bzip2 \
	cal \
	cat \
	catv \
	chat \
	chattr \
	chgrp \
	chmod \
	chown \
	chpasswd \
	chpst \
	chroot \
	chrt \
	chvt \
	cksum \
	clear \
	cmp \
	comm \
	cp \
	cpio \
	crond \
	crontab \
	cryptpw \
	cttyhack \
	cut \
	date \
	dc \
	dd \
	deallocvt \
	delgroup \
	deluser \
	depmod \
	devmem \
	df \
	dhcprelay \
	diff \
	dirname \
	dmesg \
	dnsd \
	dnsdomainname \
	dos2unix \
	du \
	dumpkmap \
	dumpleases \
	echo \
	ed \
	egrep \
	eject \
	env \
	envdir \
	envuidgid \
	ether-wake \
	expand \
	expr \
	fakeidentd \
	false \
	fbset \
	fbsplash \
	fdflush \
	fdformat \
	fdisk \
	fgconsole \
	fgrep \
	find \
	findfs \
	flock \
	fold \
	free \
	freeramdisk \
	fsck \
	fsck.minix \
	fsync \
	ftpd \
	ftpget \
	ftpput \
	fuser \
	getopt \
	getty \
	grep \
	groups \
	gunzip \
	gzip \
	halt \
	hd \
	hdparm \
	head \
	hexdump \
	hostid \
	hostname \
	httpd \
	hwclock \
	id \
	ifconfig \
	ifdown \
	ifenslave \
	ifplugd \
	ifup \
	inetd \
	init \
	insmod \
	install \
	ionice \
	iostat \
	ip \
	ipaddr \
	ipcalc \
	ipcrm \
	ipcs \
	iplink \
	iproute \
	iprule \
	iptunnel \
	kbd_mode \
	kill \
	killall \
	killall5 \
	klogd \
	last \
	less \
	linux32 \
	linux64 \
	linuxrc \
	ln \
	loadfont \
	loadkmap \
	logger \
	login \
	logname \
	logread \
	losetup \
	lpd \
	lpq \
	lpr \
	ls \
	lsattr \
	lsmod \
	lspci \
	lsusb \
	lzcat \
	lzma \
	lzop \
	lzopcat \
	makedevs \
	makemime \
	man \
	md5sum \
	mdev \
	mesg \
	microcom \
	mkdir \
	mkdosfs \
	mke2fs \
	mkfifo \
	mkfs.ext2 \
	mkfs.minix \
	mkfs.vfat \
	mknod \
	mkpasswd \
	mkswap \
	mktemp \
	modinfo \
	modprobe \
	more \
	mount \
	mountpoint \
	mpstat \
	mt \
	mv \
	nameif \
	nbd-client \
	nc \
	netstat \
	nice \
	nmeter \
	nohup \
	nslookup \
	ntpd \
	od \
	openvt \
	passwd \
	patch \
	pgrep \
	pidof \
	ping \
	ping6 \
	pipe_progress \
	pivot_root \
	pkill \
	pmap \
	popmaildir \
	poweroff \
	powertop \
	printenv \
	printf \
	ps \
	pscan \
	pstree \
	pwd \
	pwdx \
	raidautorun \
	rdate \
	rdev \
	readahead \
	readlink \
	readprofile \
	realpath \
	reboot \
	reformime \
	remove-shell \
	renice \
	reset \
	resize \
	rev \
	rm \
	rmdir \
	rmmod \
	route \
	rpm \
	rpm2cpio \
	rtcwake \
	run-parts \
	runlevel \
	runsv \
	runsvdir \
	rx \
	script \
	scriptreplay \
	sed \
	sendmail \
	seq \
	setarch \
	setconsole \
	setfont \
	setkeycodes \
	setlogcons \
	setserial \
	setsid \
	setuidgid \
	sh \
	sha1sum \
	sha256sum \
	sha512sum \
	showkey \
	slattach \
	sleep \
	smemcap \
	softlimit \
	sort \
	split \
	start-stop-daemon \
	stat \
	strings \
	stty \
	sulogin \
	sum \
	sv \
	svlogd \
	swapoff \
	swapon \
	switch_root \
	sync \
	sysctl \
	syslogd \
	tac \
	tail \
	tar \
	tcpsvd \
	tee \
	telnet \
	telnetd \
	test \
	tftp \
	tftpd \
	time \
	timeout \
	top \
	touch \
	tr \
	traceroute \
	traceroute6 \
	true \
	tty \
	ttysize \
	tunctl \
	udhcpc \
	udhcpd \
	udpsvd \
	umount \
	uname \
	uncompress \
	unexpand \
	uniq \
	unix2dos \
	unlzma \
	unlzop \
	unxz \
	unzip \
	uptime \
	users \
	usleep \
	uudecode \
	uuencode \
	vconfig \
	vi \
	vlock \
	volname \
	wall \
	watch \
	watchdog \
	wc \
	wget \
	which \
	who \
	whoami \
	whois \
	xargs \
	xz \
	xzcat \
	yes \
	zcat \
	zcip

LOCAL_MODULE := busybox

BUSYBOX_INSTALL_DIR := $(TARGET_OUT)/bin
BUSYBOX_BINARY := $(BUSYBOX_INSTALL_DIR)/busybox
BUSYBOX_LOCAL_BINARY := $(LOCAL_PATH)/busybox-android
# This dependency ensures busybox is installed after all toolbox symlinks
# are done, and overwrites them
$(BUSYBOX_BINARY): toolbox
	@cp $(BUSYBOX_LOCAL_BINARY) $(BUSYBOX_BINARY)
	@echo "Installing busybox"
	@for tool in $(BUSYBOX_TOOLS) ; do \
		rm -rf $(BUSYBOX_INSTALL_DIR)/$$tool ; \
		ln -s busybox $(BUSYBOX_INSTALL_DIR)/$$tool ; \
	done

ALL_DEFAULT_INSTALLED_MODULES += $(BUSYBOX_BINARY)
